Zeus API Reference
The Zeus GraphQL API to manage multi-cloud infrastructure on Zeupiter!
API Endpoints
https://api.zeupiter.com/v1/infra/
Headers
Authorization: Bearer <ZEUS_API_KEY>
Version
1.0.1
Welcome to the Zeus API reference! This reference includes the complete set of GraphQL types, queries, mutations, and subscriptions for the universal GraphQL API to manage multi-cloud infrastructure. WARNING: This API is under heavy development; some resolvers might change over time.
Visit your Account Settings for authentication instructions.
For support, contact us at [email protected].
Maintainer: Sagar Verma.
Review our Terms of Service.
Queries
fetchAWSInstancePricing
Description
Fetches the pricing for AWS instances in a specific region and OS.
Response
Returns a JSON
Example
Query
query fetchAWSInstancePricing(
$region: String!,
$os: String!
) {
fetchAWSInstancePricing(
region: $region,
os: $os
)
}
Variables
{
"region": "abc123",
"os": "abc123"
}
Response
{"data": {"fetchAWSInstancePricing": {}}}
fetchAWSIpPricing
Description
Fetches the pricing for AWS IP addresses.
Response
Returns a JSON
Example
Query
query fetchAWSIpPricing {
fetchAWSIpPricing
}
Response
{"data": {"fetchAWSIpPricing": {}}}
fetchAWSRegions
Description
Fetches the list of AWS regions.
Response
Returns a JSON
Example
Query
query fetchAWSRegions {
fetchAWSRegions
}
Response
{"data": {"fetchAWSRegions": {}}}
fetchAWS_EBSPricing
Description
Fetches the pricing for AWS EBS volumes.
Response
Returns a JSON
Example
Query
query fetchAWS_EBSPricing {
fetchAWS_EBSPricing
}
Response
{"data": {"fetchAWS_EBSPricing": {}}}
fetchBillingLink
Response
Returns a BillingLink
Example
Query
query fetchBillingLink {
fetchBillingLink {
userId
paymentIntents {
...PaymentIntentFragment
}
isVerified
credits {
...CreditsFragment
}
}
}
Response
{
"data": {
"fetchBillingLink": {
"userId": 4,
"paymentIntents": [PaymentIntent],
"isVerified": false,
"credits": Credits
}
}
}
fetchCloudLink
Response
Returns a CloudLink
Example
Query
query fetchCloudLink {
fetchCloudLink {
AWS {
...AWSFragment
}
GCP {
...GCPFragment
}
}
}
Response
{
"data": {
"fetchCloudLink": {
"AWS": [AWS],
"GCP": [GCP]
}
}
}
fetchGCPInstancePricing
Description
Fetches the pricing for GCP instances in a specific region and OS.
Response
Returns a JSON
Example
Query
query fetchGCPInstancePricing(
$region: String!,
$os: String!,
$usageType: String
) {
fetchGCPInstancePricing(
region: $region,
os: $os,
usageType: $usageType
)
}
Variables
{
"region": "abc123",
"os": "xyz789",
"usageType": "abc123"
}
Response
{"data": {"fetchGCPInstancePricing": {}}}
fetchGCPRegions
Description
Fetches the list of GCP regions.
Response
Returns [String!]!
Example
Query
query fetchGCPRegions {
fetchGCPRegions
}
Response
{"data": {"fetchGCPRegions": ["abc123"]}}
fetchGCPServices
Description
Fetches the details of GCP services.
Response
Returns [FetchGCPServiceDetails]
Example
Query
query fetchGCPServices {
fetchGCPServices {
id
displayName
}
}
Response
{
"data": {
"fetchGCPServices": [
{
"id": "xyz789",
"displayName": "abc123"
}
]
}
}
fetchHasOwnCloud
Response
Returns a HasOwnCloud
Arguments
| Name | Description |
|---|---|
provider - CloudProvider!
|
Example
Query
query fetchHasOwnCloud($provider: CloudProvider!) {
fetchHasOwnCloud(provider: $provider) {
provider
isOwnCloud
}
}
Variables
{"provider": "GCP"}
Response
{"data": {"fetchHasOwnCloud": {"provider": "GCP", "isOwnCloud": false}}}
fetchSSHKeys
Response
Returns [SSHKey]
Example
Query
query fetchSSHKeys {
fetchSSHKeys {
name
sshPublicKey
createdAt
}
}
Response
{
"data": {
"fetchSSHKeys": [
{
"name": "xyz789",
"sshPublicKey": "abc123",
"createdAt": "xyz789"
}
]
}
}
fetchUsageLink
Response
Returns a UsageLink
Example
Query
query fetchUsageLink {
fetchUsageLink {
costAndUsage {
...CloudUsageFragment
}
estimatedCostUsage
platformFee
feePercentage
updatedAt
}
}
Response
{
"data": {
"fetchUsageLink": {
"costAndUsage": CloudUsage,
"estimatedCostUsage": 123.45,
"platformFee": 987.65,
"feePercentage": 987.65,
"updatedAt": "xyz789"
}
}
}
getAWSAvailabilityZones
Description
Retrieves the availability zones for a given sub-region.
Response
Returns [String]
Arguments
| Name | Description |
|---|---|
subRegion - String!
|
The sub-region for which to fetch availability zones. |
Example
Query
query getAWSAvailabilityZones($subRegion: String!) {
getAWSAvailabilityZones(subRegion: $subRegion)
}
Variables
{"subRegion": "xyz789"}
Response
{
"data": {
"getAWSAvailabilityZones": ["abc123"]
}
}
getAWSCostAndUsage
Description
Retrieves the cost and usage data for AWS resources.
Response
Returns a CloudCostAndUsage!
Example
Query
query getAWSCostAndUsage(
$range: [String]!,
$granularity: String!,
$filters: Boolean
) {
getAWSCostAndUsage(
range: $range,
granularity: $granularity,
filters: $filters
) {
Groups {
...GroupFragment
}
Total {
...TotalFragment
}
Granularity
}
}
Variables
{
"range": ["xyz789"],
"granularity": "xyz789",
"filters": false
}
Response
{
"data": {
"getAWSCostAndUsage": {
"Groups": [Group],
"Total": Total,
"Granularity": "xyz789"
}
}
}
getAWSInstanceById
Description
Retrieves AWS instances by their ID.
Response
Returns [AWSInstance]
Arguments
| Name | Description |
|---|---|
id - String
|
The ID of the instance to retrieve. |
Example
Query
query getAWSInstanceById($id: String) {
getAWSInstanceById(id: $id) {
id
name
state
publicIp
privateIp
type
platform
region
imageId
architecture
keyname
availabilityZone
launchedAt
}
}
Variables
{"id": "abc123"}
Response
{
"data": {
"getAWSInstanceById": [
{
"id": "abc123",
"name": "xyz789",
"state": "xyz789",
"publicIp": "abc123",
"privateIp": "xyz789",
"type": "abc123",
"platform": "xyz789",
"region": "abc123",
"imageId": "abc123",
"architecture": "abc123",
"keyname": "xyz789",
"availabilityZone": "xyz789",
"launchedAt": "abc123"
}
]
}
}
getAWSwindowsInstancePassword
Description
Retrieves the password data for an AWS instance.
Response
Returns a PasswordDataResponse
Example
Query
query getAWSwindowsInstancePassword(
$region: String,
$instanceId: String!,
$privateKey: String
) {
getAWSwindowsInstancePassword(
region: $region,
instanceId: $instanceId,
privateKey: $privateKey
) {
success
password
message
}
}
Variables
{
"region": "abc123",
"instanceId": "xyz789",
"privateKey": "abc123"
}
Response
{
"data": {
"getAWSwindowsInstancePassword": {
"success": false,
"password": "abc123",
"message": "abc123"
}
}
}
getGCPCostAndUsage
Description
Retrieves the cost and usage data for GCP resources.
Response
Returns a CloudCostAndUsage!
Arguments
| Name | Description |
|---|---|
range - [String!]!
|
The time range for which to retrieve the cost and usage data (e.g.,['YYYY-MM-DD', 'YYYY-MM-DD']). |
granularity - String!
|
The granularity of the data (e.g., hourly, daily). |
filters - Boolean
|
Whether to apply filters to the data. |
Example
Query
query getGCPCostAndUsage(
$range: [String!]!,
$granularity: String!,
$filters: Boolean
) {
getGCPCostAndUsage(
range: $range,
granularity: $granularity,
filters: $filters
) {
Groups {
...GroupFragment
}
Total {
...TotalFragment
}
Granularity
}
}
Variables
{
"range": ["xyz789"],
"granularity": "xyz789",
"filters": false
}
Response
{
"data": {
"getGCPCostAndUsage": {
"Groups": [Group],
"Total": Total,
"Granularity": "abc123"
}
}
}
getGCPInstanceById
Description
Retrieves GCP instances by their ID.
Response
Returns a GCPInstancePaginatedResponse
Example
Query
query getGCPInstanceById(
$id: String,
$limit: Int,
$cursor: String
) {
getGCPInstanceById(
id: $id,
limit: $limit,
cursor: $cursor
) {
instances {
...GCPInstanceFragment
}
nextCursor
}
}
Variables
{
"id": "abc123",
"limit": 987,
"cursor": "abc123"
}
Response
{
"data": {
"getGCPInstanceById": {
"instances": [GCPInstance],
"nextCursor": "abc123"
}
}
}
getGCPwindowsInstancePassword
Response
Returns a PasswordDataResponse!
Example
Query
query getGCPwindowsInstancePassword(
$instanceId: String!,
$zone: String!
) {
getGCPwindowsInstancePassword(
instanceId: $instanceId,
zone: $zone
) {
success
password
message
}
}
Variables
{
"instanceId": "abc123",
"zone": "abc123"
}
Response
{
"data": {
"getGCPwindowsInstancePassword": {
"success": false,
"password": "xyz789",
"message": "abc123"
}
}
}
getZeusCloudLinkStatus
Response
Returns a ZeusCloudLinkStatus
Example
Query
query getZeusCloudLinkStatus {
getZeusCloudLinkStatus {
aws
gcp
azure
}
}
Response
{
"data": {
"getZeusCloudLinkStatus": {"aws": false, "gcp": false, "azure": false}
}
}
iam
Response
Returns an IAMPermission
Example
Query
query iam(
$action: String!,
$resource: String!,
$attributes: [String],
$isUserAttribute: Boolean
) {
iam(
action: $action,
resource: $resource,
attributes: $attributes,
isUserAttribute: $isUserAttribute
) {
granted
attributes
}
}
Variables
{
"action": "xyz789",
"resource": "abc123",
"attributes": ["abc123"],
"isUserAttribute": false
}
Response
{
"data": {
"iam": {
"granted": false,
"attributes": ["abc123"]
}
}
}
listAWSElasticIPs
Description
Lists all AWS Elastic IPs.
Response
Returns [IpList]
Example
Query
query listAWSElasticIPs {
listAWSElasticIPs {
AllocationId
AssociationId
InstanceId
PublicIp
NetworkBorderGroup
}
}
Response
{
"data": {
"listAWSElasticIPs": [
{
"AllocationId": "xyz789",
"AssociationId": "xyz789",
"InstanceId": "abc123",
"PublicIp": "xyz789",
"NetworkBorderGroup": "xyz789"
}
]
}
}
listAWSFileSystems
Description
Lists all AWS file systems.
Response
Returns [FileSystem]
Example
Query
query listAWSFileSystems {
listAWSFileSystems {
FileSystemId
Name
OwnerId
CreationTime
LifeCycleState
NumberOfMountTargets
SizeInBytes {
...SizeInBytesFragment
}
PerformanceMode
Encrypted
KmsKeyId
ThroughputMode
ProvisionedThroughputInMibps
}
}
Response
{
"data": {
"listAWSFileSystems": [
{
"FileSystemId": 4,
"Name": "abc123",
"OwnerId": "xyz789",
"CreationTime": "xyz789",
"LifeCycleState": "abc123",
"NumberOfMountTargets": 123,
"SizeInBytes": SizeInBytes,
"PerformanceMode": "abc123",
"Encrypted": true,
"KmsKeyId": "xyz789",
"ThroughputMode": "xyz789",
"ProvisionedThroughputInMibps": 987.65
}
]
}
}
listAWSSnapshots
Description
Lists all AWS snapshots.
Response
Returns [Snapshot]
Example
Query
query listAWSSnapshots {
listAWSSnapshots {
snapshotId
snapshotName
volumeId
region
progress
state
volumeSize
volumeName
startTime
instanceId
instanceName
snapshotStatus
}
}
Response
{
"data": {
"listAWSSnapshots": [
{
"snapshotId": "xyz789",
"snapshotName": "xyz789",
"volumeId": "abc123",
"region": "xyz789",
"progress": "abc123",
"state": "xyz789",
"volumeSize": 123,
"volumeName": "xyz789",
"startTime": "xyz789",
"instanceId": "abc123",
"instanceName": "xyz789",
"snapshotStatus": "xyz789"
}
]
}
}
listAWSVolumes
Description
Lists all AWS volumes.
Response
Returns [Volume]
Example
Query
query listAWSVolumes {
listAWSVolumes {
AvailabilityZone
CreateTime
Size
SnapshotId
State
VolumeId
Name
Iops
VolumeType
MultiAttachEnabled
Encrypted
KmsKeyId
OutpostArn
Throughput
Attachments {
...VolumeAttachmentFragment
}
volumeId
regionCode
state
size
volumeType
iops
encrypted
instanceId
device
}
}
Response
{
"data": {
"listAWSVolumes": [
{
"AvailabilityZone": "abc123",
"CreateTime": "xyz789",
"Size": 987,
"SnapshotId": "abc123",
"State": "abc123",
"VolumeId": "xyz789",
"Name": "xyz789",
"Iops": 123,
"VolumeType": "xyz789",
"MultiAttachEnabled": false,
"Encrypted": true,
"KmsKeyId": "abc123",
"OutpostArn": "abc123",
"Throughput": 123,
"Attachments": [VolumeAttachment],
"volumeId": "abc123",
"regionCode": "abc123",
"state": "abc123",
"size": 123,
"volumeType": "abc123",
"iops": 123,
"encrypted": true,
"instanceId": "xyz789",
"device": "xyz789"
}
]
}
}
listAWS_SSHKeys
Description
Lists all AWS SSH keys in a specific region.
Response
Returns [KeyPair]
Arguments
| Name | Description |
|---|---|
region - String!
|
The region where the SSH keys are located. |
Example
Query
query listAWS_SSHKeys($region: String!) {
listAWS_SSHKeys(region: $region) {
name
}
}
Variables
{"region": "abc123"}
Response
{
"data": {
"listAWS_SSHKeys": [{"name": "abc123"}]
}
}
listGCPElasticIPs
Description
List GCP networks (public static IPs) with pagination and filtering.
Response
Returns a GCPElasticIPsPaginatedResponse
Example
Query
query listGCPElasticIPs(
$id: String,
$limit: Int,
$cursor: String
) {
listGCPElasticIPs(
id: $id,
limit: $limit,
cursor: $cursor
) {
elasticIPs {
...GCPElasticIPFragment
}
nextCursor
}
}
Variables
{
"id": "xyz789",
"limit": 123,
"cursor": "abc123"
}
Response
{
"data": {
"listGCPElasticIPs": {
"elasticIPs": [GCPElasticIP],
"nextCursor": "xyz789"
}
}
}
listGCPSnapshots
Description
List GCP snapshots with pagination and filtering capabilities
Response
Returns a GCPSnapshotPaginatedResponse!
Arguments
| Name | Description |
|---|---|
id - String
|
Filter identifier using prefix:
|
limit - Int
|
Maximum number of results to return (default: 10, max: 100). Default = 10 |
cursor - String
|
Pagination cursor for next page of results |
Example
Query
query listGCPSnapshots(
$id: String,
$limit: Int,
$cursor: String
) {
listGCPSnapshots(
id: $id,
limit: $limit,
cursor: $cursor
) {
snapshots {
...GCPSnapshotFragment
}
nextCursor
}
}
Variables
{
"id": "abc123",
"limit": 10,
"cursor": "abc123"
}
Response
{
"data": {
"listGCPSnapshots": {
"snapshots": [GCPSnapshot],
"nextCursor": "xyz789"
}
}
}
listGCPVolumes
Description
Fetches all GCP volumes associated with the user.
Response
Returns a GCPVolumePaginatedResponse!
Example
Query
query listGCPVolumes(
$id: String,
$limit: Int,
$cursor: String
) {
listGCPVolumes(
id: $id,
limit: $limit,
cursor: $cursor
) {
volumes {
...GCPDiskFragment
}
nextCursor
}
}
Variables
{
"id": "xyz789",
"limit": 123,
"cursor": "xyz789"
}
Response
{
"data": {
"listGCPVolumes": {
"volumes": [GCPDisk],
"nextCursor": "xyz789"
}
}
}
Mutations
allocateAWSElasticIp
Description
Allocates an AWS Elastic IP.
Response
Returns an AWSElasticIPResult!
Arguments
| Name | Description |
|---|---|
region - String!
|
The region where the Elastic IP will be allocated. |
Example
Query
mutation allocateAWSElasticIp($region: String!) {
allocateAWSElasticIp(region: $region) {
allocationId
associationId
publicIp
instanceId
}
}
Variables
{"region": "abc123"}
Response
{
"data": {
"allocateAWSElasticIp": {
"allocationId": "xyz789",
"associationId": "abc123",
"publicIp": "abc123",
"instanceId": "xyz789"
}
}
}
checkAWSPermissions
Description
Checks AWS permissions.
Response
Returns a Response!
Example
Query
mutation checkAWSPermissions(
$accessKeyId: String!,
$secretAccessKey: String!
) {
checkAWSPermissions(
accessKeyId: $accessKeyId,
secretAccessKey: $secretAccessKey
) {
success
message
}
}
Variables
{
"accessKeyId": "abc123",
"secretAccessKey": "xyz789"
}
Response
{
"data": {
"checkAWSPermissions": {
"success": true,
"message": "xyz789"
}
}
}
createAWSInstance
Description
Creates an AWS instance.
Response
Returns a Response!
Arguments
| Name | Description |
|---|---|
args - CreateAWSInstanceInput!
|
The input arguments for creating the instance. |
Example
Query
mutation createAWSInstance($args: CreateAWSInstanceInput!) {
createAWSInstance(args: $args) {
success
message
}
}
Variables
{"args": CreateAWSInstanceInput}
Response
{
"data": {
"createAWSInstance": {
"success": true,
"message": "xyz789"
}
}
}
createAWSInstanceSnapshot
Description
Creates a snapshot of an AWS instance.
Response
Returns a Response!
Example
Query
mutation createAWSInstanceSnapshot(
$instanceId: String!,
$region: String!
) {
createAWSInstanceSnapshot(
instanceId: $instanceId,
region: $region
) {
success
message
}
}
Variables
{
"instanceId": "xyz789",
"region": "abc123"
}
Response
{
"data": {
"createAWSInstanceSnapshot": {
"success": true,
"message": "xyz789"
}
}
}
createAWSSecurityGroup
Description
Creates an AWS security group.
Response
Returns a String
Arguments
| Name | Description |
|---|---|
region - String!
|
The region where the security group will be created. |
Example
Query
mutation createAWSSecurityGroup($region: String!) {
createAWSSecurityGroup(region: $region)
}
Variables
{"region": "xyz789"}
Response
{
"data": {
"createAWSSecurityGroup": "xyz789"
}
}
createAWSStorage
Description
Creates AWS storage.
Response
Returns a Response!
Example
Query
mutation createAWSStorage(
$size: Int!,
$type: String!,
$name: String!,
$region: String!,
$zone: String!
) {
createAWSStorage(
size: $size,
type: $type,
name: $name,
region: $region,
zone: $zone
) {
success
message
}
}
Variables
{
"size": 123,
"type": "abc123",
"name": "xyz789",
"region": "xyz789",
"zone": "abc123"
}
Response
{
"data": {
"createAWSStorage": {
"success": true,
"message": "abc123"
}
}
}
createAWS_EFS
Description
Creates an AWS EFS.
Response
Returns an Efs
Example
Query
mutation createAWS_EFS(
$name: String!,
$region: String!,
$a_zone: String
) {
createAWS_EFS(
name: $name,
region: $region,
a_zone: $a_zone
) {
fileSystemId
fileSystemName
regionCode
state
size
encrypted
createdAt
updatedAt
}
}
Variables
{
"name": "abc123",
"region": "xyz789",
"a_zone": "xyz789"
}
Response
{
"data": {
"createAWS_EFS": {
"fileSystemId": "abc123",
"fileSystemName": "xyz789",
"regionCode": "abc123",
"state": "abc123",
"size": 123,
"encrypted": true,
"createdAt": "xyz789",
"updatedAt": "xyz789"
}
}
}
createGCPInstance
Description
Creates a GCP instance.
Response
Returns a Response!
Arguments
| Name | Description |
|---|---|
args - CreateGCPInstanceInput!
|
The input arguments for creating the instance. |
Example
Query
mutation createGCPInstance($args: CreateGCPInstanceInput!) {
createGCPInstance(args: $args) {
success
message
}
}
Variables
{"args": CreateGCPInstanceInput}
Response
{
"data": {
"createGCPInstance": {
"success": false,
"message": "xyz789"
}
}
}
createNewsEvent
Response
Returns a NewsEvent
Example
Query
mutation createNewsEvent(
$id: String!,
$title: String,
$description: String
) {
createNewsEvent(
id: $id,
title: $title,
description: $description
) {
id
title
description
}
}
Variables
{
"id": "xyz789",
"title": "xyz789",
"description": "xyz789"
}
Response
{
"data": {
"createNewsEvent": {
"id": "abc123",
"title": "abc123",
"description": "xyz789"
}
}
}
createSSHKey
Example
Query
mutation createSSHKey(
$name: String!,
$sshPublicKey: String!
) {
createSSHKey(
name: $name,
sshPublicKey: $sshPublicKey
) {
success
message
}
}
Variables
{
"name": "xyz789",
"sshPublicKey": "abc123"
}
Response
{
"data": {
"createSSHKey": {
"success": false,
"message": "xyz789"
}
}
}
deleteAWSAccessKeys
Response
Returns a Response!
Example
Query
mutation deleteAWSAccessKeys {
deleteAWSAccessKeys {
success
message
}
}
Response
{
"data": {
"deleteAWSAccessKeys": {
"success": true,
"message": "abc123"
}
}
}
deleteAWSInstanceSnapshots
Description
Deletes AWS instance snapshots.
Response
Returns a Response!
Example
Query
mutation deleteAWSInstanceSnapshots(
$snapshotName: String!,
$region: String!
) {
deleteAWSInstanceSnapshots(
snapshotName: $snapshotName,
region: $region
) {
success
message
}
}
Variables
{
"snapshotName": "abc123",
"region": "abc123"
}
Response
{
"data": {
"deleteAWSInstanceSnapshots": {
"success": true,
"message": "xyz789"
}
}
}
deleteAWS_EFS
Description
Deletes an AWS EFS.
Response
Returns a Response!
Example
Query
mutation deleteAWS_EFS(
$fileSystemId: String!,
$region: String!
) {
deleteAWS_EFS(
fileSystemId: $fileSystemId,
region: $region
) {
success
message
}
}
Variables
{
"fileSystemId": "abc123",
"region": "abc123"
}
Response
{
"data": {
"deleteAWS_EFS": {
"success": true,
"message": "abc123"
}
}
}
deleteGCPAccessKeys
Response
Returns a Response!
Example
Query
mutation deleteGCPAccessKeys {
deleteGCPAccessKeys {
success
message
}
}
Response
{
"data": {
"deleteGCPAccessKeys": {
"success": false,
"message": "abc123"
}
}
}
deleteSSHKey
executeAWSCommand
Description
Executes a command on an AWS instance.
Response
Returns a CommandResult!
Example
Query
mutation executeAWSCommand(
$instanceId: String!,
$command: String!,
$region: String!
) {
executeAWSCommand(
instanceId: $instanceId,
command: $command,
region: $region
) {
success
commandId
message
}
}
Variables
{
"instanceId": "abc123",
"command": "abc123",
"region": "abc123"
}
Response
{
"data": {
"executeAWSCommand": {
"success": true,
"commandId": "xyz789",
"message": "xyz789"
}
}
}
importAWSKeyPair
Description
Imports an AWS key pair.
Response
Returns a Response!
Example
Query
mutation importAWSKeyPair(
$keyName: String!,
$publicKey: String!,
$region: String!
) {
importAWSKeyPair(
keyName: $keyName,
publicKey: $publicKey,
region: $region
) {
success
message
}
}
Variables
{
"keyName": "xyz789",
"publicKey": "xyz789",
"region": "xyz789"
}
Response
{
"data": {
"importAWSKeyPair": {
"success": false,
"message": "xyz789"
}
}
}
manageAWSElasticIP
Description
Manages an AWS Elastic IP.
Response
Returns an AWSElasticIPResult
Arguments
| Name | Description |
|---|---|
action - String!
|
The action to perform on the Elastic IP. |
instanceId - String
|
The instance ID associated with the Elastic IP. |
allocationId - String
|
The allocation ID of the Elastic IP. |
associationId - String
|
The association ID of the Elastic IP. |
region - String!
|
The region where the Elastic IP is located. |
Example
Query
mutation manageAWSElasticIP(
$action: String!,
$instanceId: String,
$allocationId: String,
$associationId: String,
$region: String!
) {
manageAWSElasticIP(
action: $action,
instanceId: $instanceId,
allocationId: $allocationId,
associationId: $associationId,
region: $region
) {
allocationId
associationId
publicIp
instanceId
}
}
Variables
{
"action": "xyz789",
"instanceId": "xyz789",
"allocationId": "xyz789",
"associationId": "xyz789",
"region": "abc123"
}
Response
{
"data": {
"manageAWSElasticIP": {
"allocationId": "xyz789",
"associationId": "abc123",
"publicIp": "abc123",
"instanceId": "abc123"
}
}
}
manageAWSInstance
Description
Manages an AWS instance (start, stop, reboot, terminate).
Response
Returns a Response
Arguments
| Name | Description |
|---|---|
region - String!
|
The region where the instance is located. |
instanceId - [String]
|
The IDs of the instances to manage. |
action - AWSInstanceAction!
|
The action to perform on the instance. |
Example
Query
mutation manageAWSInstance(
$region: String!,
$instanceId: [String],
$action: AWSInstanceAction!
) {
manageAWSInstance(
region: $region,
instanceId: $instanceId,
action: $action
) {
success
message
}
}
Variables
{
"region": "xyz789",
"instanceId": ["abc123"],
"action": "START"
}
Response
{
"data": {
"manageAWSInstance": {
"success": false,
"message": "xyz789"
}
}
}
manageAWSVolume
Description
Manages an AWS volume.
Response
Returns a Volume
Arguments
| Name | Description |
|---|---|
action - VolumeAction!
|
The action to perform on the volume. |
volumeId - String
|
The ID of the volume. |
instanceId - String
|
The instance ID to which the volume is attached. |
device - String
|
The device name of the volume. |
region - String
|
The region where the volume is located. |
Example
Query
mutation manageAWSVolume(
$action: VolumeAction!,
$volumeId: String,
$instanceId: String,
$device: String,
$region: String
) {
manageAWSVolume(
action: $action,
volumeId: $volumeId,
instanceId: $instanceId,
device: $device,
region: $region
) {
AvailabilityZone
CreateTime
Size
SnapshotId
State
VolumeId
Name
Iops
VolumeType
MultiAttachEnabled
Encrypted
KmsKeyId
OutpostArn
Throughput
Attachments {
...VolumeAttachmentFragment
}
volumeId
regionCode
state
size
volumeType
iops
encrypted
instanceId
device
}
}
Variables
{
"action": "create",
"volumeId": "abc123",
"instanceId": "abc123",
"device": "xyz789",
"region": "xyz789"
}
Response
{
"data": {
"manageAWSVolume": {
"AvailabilityZone": "xyz789",
"CreateTime": "xyz789",
"Size": 987,
"SnapshotId": "abc123",
"State": "abc123",
"VolumeId": "abc123",
"Name": "abc123",
"Iops": 987,
"VolumeType": "xyz789",
"MultiAttachEnabled": false,
"Encrypted": false,
"KmsKeyId": "abc123",
"OutpostArn": "xyz789",
"Throughput": 123,
"Attachments": [VolumeAttachment],
"volumeId": "xyz789",
"regionCode": "xyz789",
"state": "abc123",
"size": 123,
"volumeType": "abc123",
"iops": 987,
"encrypted": true,
"instanceId": "xyz789",
"device": "abc123"
}
}
}
manageGCPElasticIP
Description
Manages a GCP Elastic/Static IP.
Response
Returns a ManageGCPElasticIPResponse!
Arguments
| Name | Description |
|---|---|
action - GCPElasticIPAction!
|
The action to perform on the Elastic IP. |
ipName - String
|
The name of the Elastic IP, known as address in GCP. Required for DESCRIBE, ALLOCATE & RELEASE actions. |
instanceName - String
|
The name of the instance. Required for ASSOCIATE & DISASSOCIATE actions. |
publicIp - String
|
The public IP address. Required for ASSOCIATE & DISASSOCIATE actions. |
ipRegion - String
|
The region where the Elastic IP is located (e.g., us-east1). Required for ALLOCATE & DESCRIBE actions. |
Example
Query
mutation manageGCPElasticIP(
$action: GCPElasticIPAction!,
$ipName: String,
$instanceName: String,
$publicIp: String,
$ipRegion: String
) {
manageGCPElasticIP(
action: $action,
ipName: $ipName,
instanceName: $instanceName,
publicIp: $publicIp,
ipRegion: $ipRegion
) {
... on ManageGCPElasticIPResponseMinimal {
...ManageGCPElasticIPResponseMinimalFragment
}
... on GCPElasticIP {
...GCPElasticIPFragment
}
}
}
Variables
{
"action": "ALLOCATE",
"ipName": "xyz789",
"instanceName": "xyz789",
"publicIp": "xyz789",
"ipRegion": "xyz789"
}
Response
{
"data": {
"manageGCPElasticIP": ManageGCPElasticIPResponseMinimal
}
}
manageGCPInstance
Description
Manages a GCP instance (start, stop, reboot, delete).
Response
Returns a Response!
Arguments
| Name | Description |
|---|---|
zone - String!
|
The zone where the instance is located (e.g., us-east1-a). |
instanceId - [String!]!
|
The IDs of the instances to manage. |
action - GCPInstanceAction!
|
The action to perform on the instance. |
Example
Query
mutation manageGCPInstance(
$zone: String!,
$instanceId: [String!]!,
$action: GCPInstanceAction!
) {
manageGCPInstance(
zone: $zone,
instanceId: $instanceId,
action: $action
) {
success
message
}
}
Variables
{
"zone": "xyz789",
"instanceId": ["xyz789"],
"action": "START"
}
Response
{
"data": {
"manageGCPInstance": {
"success": true,
"message": "abc123"
}
}
}
manageGCPSnapshot
Description
Manage GCP snapshots (create, describe, restore, delete).
Response
Returns a ManageGCPSnapshotResponse!
Arguments
| Name | Description |
|---|---|
action - GcpSnapshotAction!
|
The action to perform (CREATE, DESCRIBE, RESTORE, DELETE). |
region - String
|
The region where the volume is located (e.g., us-east1). |
volumeName - String
|
The ID of the volume to create a snapshot for (required for CREATE). |
instanceName - String
|
The ID of the volume to create a snapshot for (required for CREATE, optional for DELETE). |
snapshotName - String
|
The name of the snapshot (optional for CREATE, optional for DELETE). |
Example
Query
mutation manageGCPSnapshot(
$action: GcpSnapshotAction!,
$region: String,
$volumeName: String,
$instanceName: String,
$snapshotName: String
) {
manageGCPSnapshot(
action: $action,
region: $region,
volumeName: $volumeName,
instanceName: $instanceName,
snapshotName: $snapshotName
) {
... on ManageGCPSnapshotResponseMinimal {
...ManageGCPSnapshotResponseMinimalFragment
}
... on GCPSnapshot {
...GCPSnapshotFragment
}
}
}
Variables
{
"action": "CREATE",
"region": "xyz789",
"volumeName": "xyz789",
"instanceName": "abc123",
"snapshotName": "xyz789"
}
Response
{
"data": {
"manageGCPSnapshot": ManageGCPSnapshotResponseMinimal
}
}
manageGCPVolume
Description
Mutation to manage GCP volumes. This mutation supports the following actions:
- CREATE: Create a new GCP volume.
- DESCRIBE: Retrieve details of an existing GCP volume.
- ATTACH: Attach an existing GCP volume to an instance.
- DETACH: Detach a GCP volume from an instance.
- TERMINATE: Delete an existing GCP volume.
Response
Returns a ManageGCPVolumeResponse!
Arguments
| Name | Description |
|---|---|
action - GCPVolumeAction!
|
The action to perform on the GCP volume. |
volumeName - String!
|
The name of the volume. |
volumeSize - Int
|
The size of the volume in gigabytes (GB). Required for CREATE action. |
volumeType - String
|
The type of the volume (e.g., pd-standard, pd-ssd, pd-balanced). Optional for CREATE action. |
instanceName - String
|
The name of the instance. Required for ATTACH actions. |
zone - String!
|
The GCP zone where the volume resides or will be created (e.g., asia-south1-b). Required for all actions. |
Example
Query
mutation manageGCPVolume(
$action: GCPVolumeAction!,
$volumeName: String!,
$volumeSize: Int,
$volumeType: String,
$instanceName: String,
$zone: String!
) {
manageGCPVolume(
action: $action,
volumeName: $volumeName,
volumeSize: $volumeSize,
volumeType: $volumeType,
instanceName: $instanceName,
zone: $zone
) {
... on ManageGCPVolumeResponseMinimal {
...ManageGCPVolumeResponseMinimalFragment
}
... on GCPDisk {
...GCPDiskFragment
}
}
}
Variables
{
"action": "CREATE",
"volumeName": "abc123",
"volumeSize": 987,
"volumeType": "abc123",
"instanceName": "abc123",
"zone": "abc123"
}
Response
{
"data": {
"manageGCPVolume": ManageGCPVolumeResponseMinimal
}
}
restoreAWSInstanceSnapshot
Description
Restores an AWS instance from a snapshot.
Response
Returns a Response!
Example
Query
mutation restoreAWSInstanceSnapshot(
$instanceId: String!,
$region: String!
) {
restoreAWSInstanceSnapshot(
instanceId: $instanceId,
region: $region
) {
success
message
}
}
Variables
{
"instanceId": "xyz789",
"region": "abc123"
}
Response
{
"data": {
"restoreAWSInstanceSnapshot": {
"success": true,
"message": "abc123"
}
}
}
setGCPLinuxInstanceUsernameAndPassword
Description
Set username & password for GCP linux instance.
Response
Returns a Response
Example
Query
mutation setGCPLinuxInstanceUsernameAndPassword(
$instanceName: String!,
$zone: String!,
$username: String!,
$keyName: String!
) {
setGCPLinuxInstanceUsernameAndPassword(
instanceName: $instanceName,
zone: $zone,
username: $username,
keyName: $keyName
) {
success
message
}
}
Variables
{
"instanceName": "xyz789",
"zone": "xyz789",
"username": "xyz789",
"keyName": "abc123"
}
Response
{
"data": {
"setGCPLinuxInstanceUsernameAndPassword": {
"success": false,
"message": "abc123"
}
}
}
setGCPwindowsInstancePassword
Description
Set username & password for GCP windows instance.
Response
Returns a Response
Example
Query
mutation setGCPwindowsInstancePassword(
$instanceName: String!,
$zone: String!,
$username: String!,
$password: String!
) {
setGCPwindowsInstancePassword(
instanceName: $instanceName,
zone: $zone,
username: $username,
password: $password
) {
success
message
}
}
Variables
{
"instanceName": "abc123",
"zone": "abc123",
"username": "xyz789",
"password": "xyz789"
}
Response
{
"data": {
"setGCPwindowsInstancePassword": {
"success": false,
"message": "xyz789"
}
}
}
switchGCPCloudInfra
Description
Switch between personal/zeupiter cloud infrastructure.
Response
Returns a Response!
Arguments
| Name | Description |
|---|---|
infra - InfraType!
|
Example
Query
mutation switchGCPCloudInfra($infra: InfraType!) {
switchGCPCloudInfra(infra: $infra) {
success
message
}
}
Variables
{"infra": "PERSONAL"}
Response
{
"data": {
"switchGCPCloudInfra": {
"success": true,
"message": "xyz789"
}
}
}
Subscriptions
instanceAWSStatusUpdate
Description
Subscribes to AWS instance status updates.
Response
Returns an InstanceStatusUpdate
Arguments
| Name | Description |
|---|---|
instanceId - String!
|
The ID of the instance to monitor for status updates. |
Example
Query
subscription instanceAWSStatusUpdate($instanceId: String!) {
instanceAWSStatusUpdate(instanceId: $instanceId) {
id
state
publicIp
launchedAt
}
}
Variables
{"instanceId": "xyz789"}
Response
{
"data": {
"instanceAWSStatusUpdate": {
"id": "abc123",
"state": "xyz789",
"publicIp": "abc123",
"launchedAt": "xyz789"
}
}
}
instanceGCPStatusUpdate
Description
Subscribes to GCP instance status updates.
Response
Returns an InstanceStatusUpdate
Arguments
| Name | Description |
|---|---|
instanceId - String!
|
The ID of the instance to monitor for status updates. |
Example
Query
subscription instanceGCPStatusUpdate($instanceId: String!) {
instanceGCPStatusUpdate(instanceId: $instanceId) {
id
state
publicIp
launchedAt
}
}
Variables
{"instanceId": "xyz789"}
Response
{
"data": {
"instanceGCPStatusUpdate": {
"id": "abc123",
"state": "abc123",
"publicIp": "xyz789",
"launchedAt": "xyz789"
}
}
}
snapshotAWSStatusUpdate
Description
Subscribes to AWS snapshot status updates.
Response
Returns [AWSSnapshotStatusUpdate]
Example
Query
subscription snapshotAWSStatusUpdate {
snapshotAWSStatusUpdate {
snapshotId
status
}
}
Response
{
"data": {
"snapshotAWSStatusUpdate": [
{
"snapshotId": "xyz789",
"status": "xyz789"
}
]
}
}
snapshotGCPStatusUpdate
Description
Subscribes to GCP snapshot status updates.
Response
Returns a GCPSnapshotStatusUpdate
Arguments
| Name | Description |
|---|---|
snapshotId - String!
|
The ID of the snapshot to monitor for status updates. |
Example
Query
subscription snapshotGCPStatusUpdate($snapshotId: String!) {
snapshotGCPStatusUpdate(snapshotId: $snapshotId) {
snapshotId
progress
}
}
Variables
{"snapshotId": "xyz789"}
Response
{
"data": {
"snapshotGCPStatusUpdate": {
"snapshotId": "abc123",
"progress": 123
}
}
}
Types
AWS
Example
{
"accountId": "xyz789",
"keys": AWSKeys,
"isAWSValidated": false,
"instances": [ZeusInstance],
"efs": [AWSEFS],
"instanceCount": 123,
"ipCount": 123,
"volumeCount": 123,
"snapCount": 123,
"efsCount": 123
}
AWSEFS
AWSElasticIPResult
Description
Represents the result of an AWS Elastic IP operation.
Example
{
"allocationId": "xyz789",
"associationId": "abc123",
"publicIp": "xyz789",
"instanceId": "xyz789"
}
AWSInstance
Description
Represents an AWS instance.
Fields
| Field Name | Description |
|---|---|
id - String!
|
The unique identifier for the instance. |
name - String!
|
The name of the instance. |
state - String!
|
The current state of the instance (e.g., running, stopped). |
publicIp - String
|
The public IP address of the instance. |
privateIp - String
|
The private IP address of the instance. |
type - String!
|
The type of the instance (e.g., t2.micro). |
platform - String
|
The platform of the instance (e.g., Linux, Windows). |
region - String!
|
The region where the instance is located. |
imageId - String
|
The ID of the image used to launch the instance. |
architecture - String!
|
The architecture of the instance (e.g., x86_64). |
keyname - String!
|
The name of the key pair associated with the instance. |
availabilityZone - String!
|
The availability zone of the instance. |
launchedAt - String!
|
The timestamp when the instance was launched. |
Example
{
"id": "abc123",
"name": "xyz789",
"state": "xyz789",
"publicIp": "xyz789",
"privateIp": "abc123",
"type": "abc123",
"platform": "abc123",
"region": "xyz789",
"imageId": "xyz789",
"architecture": "abc123",
"keyname": "abc123",
"availabilityZone": "abc123",
"launchedAt": "xyz789"
}
AWSInstanceAction
Description
Represents actions that can be performed on an AWS instance.
Values
| Enum Value | Description |
|---|---|
|
|
Starts the instance. |
|
|
Stops the instance. |
|
|
Reboots the instance. |
|
|
Terminates the instance. |
Example
"START"
AWSKeys
AWSSnapshotStatusUpdate
BillingLink
Fields
| Field Name | Description |
|---|---|
userId - ID!
|
|
paymentIntents - [PaymentIntent]!
|
|
isVerified - Boolean!
|
|
credits - Credits!
|
Example
{
"userId": 4,
"paymentIntents": [PaymentIntent],
"isVerified": false,
"credits": Credits
}
Boolean
Description
The Boolean scalar type represents true or false.
Example
true
CloudCostAndUsage
CloudLink
CloudProvider
Values
| Enum Value | Description |
|---|---|
|
|
|
|
|
|
|
|
Example
"GCP"
CloudUsage
Fields
| Field Name | Description |
|---|---|
AWS - CloudCostAndUsage
|
Example
{"AWS": CloudCostAndUsage}
CommandResult
Description
Represents the result of executing a command on an AWS instance.
Example
{
"success": false,
"commandId": "xyz789",
"message": "abc123"
}
CreateAWSInstanceInput
Description
Input type for creating an AWS instance.
Fields
| Input Field | Description |
|---|---|
regionCode - String!
|
The region code where the instance will be created. |
instanceRegion - String!
|
The region where the instance will be created. |
instanceOs - String!
|
The operating system of the instance. |
instanceType - String!
|
The type of the instance. |
minCount - Int
|
The minimum number of instances to create. |
maxCount - Int
|
The maximum number of instances to create. |
imageId - String!
|
The ID of the image to be used for the instance. |
volumeSize - Int!
|
The size of the volume to be attached to the instance. |
volumeType - String!
|
The type of volume to be attached to the instance. |
deleteVolumeOnTermination - Boolean
|
Whether to delete the volume when the instance is terminated. |
instanceName - String!
|
The name of the instance. |
keyName - String!
|
The name of the key pair associated with the instance. |
ipType - IPType!
|
The type of IP address to be assigned to the instance (e.g., "static", "dynamic"). |
usageType - InstanceUsageType
|
The usage type (e.g., "ON_DEMAND", "SPOT"). |
Example
{
"regionCode": "abc123",
"instanceRegion": "xyz789",
"instanceOs": "xyz789",
"instanceType": "xyz789",
"minCount": 987,
"maxCount": 123,
"imageId": "xyz789",
"volumeSize": 123,
"volumeType": "xyz789",
"deleteVolumeOnTermination": true,
"instanceName": "abc123",
"keyName": "xyz789",
"ipType": "static",
"usageType": "ON_DEMAND"
}
CreateGCPInstanceInput
Description
Input type for creating a GCP instance.
Fields
| Input Field | Description |
|---|---|
instanceName - String!
|
The name of the instance to be created. |
zone - String!
|
The zone where the instance will be created (e.g., us-east1-a). |
instanceOs - String!
|
The operating system of the instance (e.g., Linux or Windows). |
machineType - String!
|
The type of machine to be used for the instance. |
imageId - String!
|
The ID of the image to be used for the instance. |
volumeSize - Int!
|
The size of the volume to be attached to the instance. |
volumeType - String!
|
The type of volume to be attached to the instance. |
deleteVolumeOnTermination - Boolean
|
Whether to delete the volume when the instance is terminated. |
ipType - String
|
The type of IP address to be assigned to the instance. |
usageType - InstanceUsageType
|
The usage type (e.g., "ON_DEMAND", "SPOT"). |
keyName - String!
|
The name of the SSH key pair associated with the instance. |
Example
{
"instanceName": "xyz789",
"zone": "xyz789",
"instanceOs": "abc123",
"machineType": "abc123",
"imageId": "xyz789",
"volumeSize": 987,
"volumeType": "xyz789",
"deleteVolumeOnTermination": false,
"ipType": "xyz789",
"usageType": "ON_DEMAND",
"keyName": "xyz789"
}
Credits
Fields
| Field Name | Description |
|---|---|
balance - Float!
|
|
topUp - Float!
|
|
topUpDate - String
|
|
expirationDate - String
|
|
topupHistory - [TopupHistory!]!
|
Example
{
"balance": 123.45,
"topUp": 987.65,
"topUpDate": "xyz789",
"expirationDate": "abc123",
"topupHistory": [TopupHistory]
}
Efs
Description
Represents an AWS EFS.
Fields
| Field Name | Description |
|---|---|
fileSystemId - String
|
The ID of the file system. |
fileSystemName - String
|
The name of the file system. |
regionCode - String
|
The region code where the file system is located. |
state - String
|
The state of the file system. |
size - Int
|
The size of the file system. |
encrypted - Boolean
|
Whether the file system is encrypted. |
createdAt - String
|
The creation time of the file system. |
updatedAt - String
|
The last update time of the file system. |
Example
{
"fileSystemId": "xyz789",
"fileSystemName": "abc123",
"regionCode": "abc123",
"state": "abc123",
"size": 987,
"encrypted": true,
"createdAt": "xyz789",
"updatedAt": "abc123"
}
FetchGCPServiceDetails
FileSystem
Description
Represents an AWS file system.
Fields
| Field Name | Description |
|---|---|
FileSystemId - ID
|
The ID of the file system. |
Name - String
|
The name of the file system. |
OwnerId - String
|
The owner ID of the file system. |
CreationTime - String
|
The creation time of the file system. |
LifeCycleState - String
|
The lifecycle state of the file system. |
NumberOfMountTargets - Int
|
The number of mount targets. |
SizeInBytes - SizeInBytes
|
The size of the file system in bytes. |
PerformanceMode - String
|
The performance mode of the file system. |
Encrypted - Boolean
|
Whether the file system is encrypted. |
KmsKeyId - String
|
The KMS key ID used for encryption. |
ThroughputMode - String
|
The throughput mode of the file system. |
ProvisionedThroughputInMibps - Float
|
The provisioned throughput in MiB/s. |
Example
{
"FileSystemId": 4,
"Name": "xyz789",
"OwnerId": "xyz789",
"CreationTime": "abc123",
"LifeCycleState": "abc123",
"NumberOfMountTargets": 123,
"SizeInBytes": SizeInBytes,
"PerformanceMode": "xyz789",
"Encrypted": true,
"KmsKeyId": "abc123",
"ThroughputMode": "abc123",
"ProvisionedThroughputInMibps": 987.65
}
Float
Description
The Float scalar type represents signed double-precision fractional values as specified by IEEE 754.
Example
123.45
GCP
Example
{
"accountId": "abc123",
"keys": [GCPKeys],
"isGCPValidated": false,
"instances": [ZeusInstance],
"efs": [AWSEFS],
"instanceCount": 123,
"ipCount": 987,
"volumeCount": 123,
"snapCount": 123,
"efsCount": 123
}
GCPDisk
Description
Full details of a GCP Volume (Disk). This type contains all the fields available for a GCP disk resource.
Fields
| Field Name | Description |
|---|---|
id - ID!
|
The unique identifier for the disk. |
name - String!
|
The name of the disk. |
size - Int!
|
The size of the disk in gigabytes (GB). |
type - String!
|
The type of disk (e.g., pd-standard, pd-ssd). |
zone - String
|
The zone where the disk is located (e.g., us-central1-a). |
status - String!
|
The status of the disk (e.g., READY, CREATING). |
state - String!
|
The status of the disk attached to(e.g., in-use, available). |
description - String
|
A user-provided description of the disk (if any). |
createdAt - String!
|
The timestamp when the disk was created. |
labels - [GcpLabels]
|
Key-value pairs for labels applied to the disk. |
selfLink - String
|
The full URL for the disk resource. |
users - [String!]
|
An array of instance URLs to which the disk is attached. |
sourceImage - String
|
The URL of the source image used to create the disk (if applicable). |
sourceImageId - String
|
The unique ID of the source image. |
sourceSnapshot - String
|
The URL of the source snapshot used to create the disk (if applicable). |
sourceSnapshotId - String
|
The unique ID of the source snapshot. |
licenses - [String!]
|
An array of license URLs associated with the disk (if applicable). |
diskEncryptionKey - GCPDiskEncryptionKey
|
Information about the encryption key used for the disk. |
guestOsFeatures - [GCPGuestOsFeature!]
|
An array of features supported by the guest OS (if applicable). |
lastAttachTimestamp - String
|
The timestamp when the disk was last attached. |
lastDetachTimestamp - String
|
The timestamp when the disk was last detached. |
provisionedIops - Int
|
The provisioned IOPS (Input/Output Operations Per Second) for the disk (if applicable). |
provisionedThroughput - Int
|
The provisioned throughput for the disk (if applicable). |
multiWriter - Boolean
|
Indicates whether the disk is in multi-writer mode (if applicable). |
resourcePolicies - [String!]
|
An array of resource policy URLs applied to the disk (e.g., for snapshots). |
deleteVolumeOnTermination - Boolean
|
Whether the disk will be automatically deleted when the instance is deleted |
isBootVolume - Boolean
|
Whether this disk is a boot disk |
attachedTo - String
|
Volume is attached to any instances |
Example
{
"id": 4,
"name": "abc123",
"size": 123,
"type": "xyz789",
"zone": "abc123",
"status": "abc123",
"state": "xyz789",
"description": "xyz789",
"createdAt": "abc123",
"labels": [GcpLabels],
"selfLink": "xyz789",
"users": ["abc123"],
"sourceImage": "xyz789",
"sourceImageId": "xyz789",
"sourceSnapshot": "xyz789",
"sourceSnapshotId": "abc123",
"licenses": ["xyz789"],
"diskEncryptionKey": GCPDiskEncryptionKey,
"guestOsFeatures": [GCPGuestOsFeature],
"lastAttachTimestamp": "xyz789",
"lastDetachTimestamp": "abc123",
"provisionedIops": 987,
"provisionedThroughput": 123,
"multiWriter": false,
"resourcePolicies": ["xyz789"],
"deleteVolumeOnTermination": true,
"isBootVolume": false,
"attachedTo": "abc123"
}
GCPDiskEncryptionKey
Description
Represents the encryption key used for the disk. This type contains details about the encryption key, such as the KMS key name and SHA-256 hash.
Example
{
"kmsKeyName": "xyz789",
"sha256": "xyz789"
}
GCPElasticIP
Description
Represents a GCP Elastic/Static IP.
Fields
| Field Name | Description |
|---|---|
id - ID!
|
The allocation ID of the Elastic IP. |
name - String!
|
The unique name of the Elastic IP. |
ip - String!
|
The public IP address of the Elastic IP. |
region - String!
|
The region where the Elastic IP is allocated (e.g. us-east1). |
status - String!
|
The status of the Elastic IP (e.g., IN_USE, RESERVED). |
labels - [GcpLabels!]
|
Labels associated with the Elastic IP (e.g., user ID, cost center). |
associatedTo - String
|
The instance to which the Elastic IP is associated (if any). |
description - String
|
A description of the Elastic IP. |
addressType - String
|
The type of address (e.g., EXTERNAL, INTERNAL). |
createdAt - String!
|
The creation timestamp of the Elastic IP (e.g., "2023-10-01T12:34:56.789Z"). |
networkTier - String
|
The network tier of the Elastic IP (e.g., STANDARD, PREMIUM). |
Example
{
"id": "4",
"name": "abc123",
"ip": "abc123",
"region": "xyz789",
"status": "abc123",
"labels": [GcpLabels],
"associatedTo": "xyz789",
"description": "xyz789",
"addressType": "xyz789",
"createdAt": "xyz789",
"networkTier": "abc123"
}
GCPElasticIPAction
Description
Represents actions that can be performed on GCP Elastic IPs.
Values
| Enum Value | Description |
|---|---|
|
|
Allocates a new Elastic IP. |
|
|
Describes the details of an Elastic IP. |
|
|
Associates an Elastic IP with an instance. |
|
|
Disassociates an Elastic IP from an instance. |
|
|
Releases an Elastic IP. |
Example
"ALLOCATE"
GCPElasticIPsPaginatedResponse
Description
Response type for listing GCP networks.
Fields
| Field Name | Description |
|---|---|
elasticIPs - [GCPElasticIP!]
|
A list of GCP networks. |
nextCursor - String
|
The cursor for the next page of results. If null, there are no more results. |
Example
{
"elasticIPs": [GCPElasticIP],
"nextCursor": "abc123"
}
GCPGuestOsFeature
Description
Represents a feature supported by the guest OS. This type contains the type of guest OS feature (e.g., UEFI_COMPATIBLE, VIRTIO_SCSI_MULTIQUEUE).
Fields
| Field Name | Description |
|---|---|
type - String!
|
The type of guest OS feature. |
Example
{"type": "abc123"}
GCPInstance
Description
Represents a GCP instance.
Fields
| Field Name | Description |
|---|---|
id - String!
|
Unique numeric identifier for the instance. |
name - String!
|
The name of the instance. |
zone - String!
|
The zone where the instance is running (e.g., us-east1-a). |
type - String!
|
The type of machine (e.g., n1-standard-1). |
state - String
|
The status of the instance (e.g., RUNNING). |
os - String
|
The operating system. |
architecture - String!
|
The CPU architecture (e.g., x86, ARM). |
launchedAt - String!
|
The date and time when the instance was created. |
publicIp - String!
|
The external (public) IP address, if available. |
privateIp - String!
|
The internal (private) IP address. |
tags - [String]
|
The list of network tags associated with the instance. |
disks - [GCPDisk]
|
The array of attached disks with relevant details. |
selfLink - String!
|
The fully qualified URI for the instance. |
region - String!
|
The region where the instance is located (e.g., us-east1). |
availabilityZone - String!
|
The availability zone of the instance (e.g., us-east1-a). |
scheduling - GcpScheduling
|
The scheduling information (e.g., preemptibility). |
labels - [GcpLabels]
|
The key-value pairs of labels associated with the instance. |
platform - String
|
Instance platform (e.g., Windows, Linux) |
imageId - String
|
ImageId used to create the instance |
networkInterfaces - [GcpNetworkInterface!]
|
The network interfaces details. |
Example
{
"id": "xyz789",
"name": "xyz789",
"zone": "xyz789",
"type": "abc123",
"state": "abc123",
"os": "xyz789",
"architecture": "xyz789",
"launchedAt": "abc123",
"publicIp": "abc123",
"privateIp": "xyz789",
"tags": ["xyz789"],
"disks": [GCPDisk],
"selfLink": "abc123",
"region": "abc123",
"availabilityZone": "abc123",
"scheduling": GcpScheduling,
"labels": [GcpLabels],
"platform": "xyz789",
"imageId": "xyz789",
"networkInterfaces": [GcpNetworkInterface]
}
GCPInstanceAction
Description
Represents actions that can be performed on a GCP instance.
Values
| Enum Value | Description |
|---|---|
|
|
Starts the instance. |
|
|
Stops the instance. |
|
|
Reboots the instance. |
|
|
Terminates the instance. |
Example
"START"
GCPInstancePaginatedResponse
Description
Represents a paginated result of GCP instances.
Fields
| Field Name | Description |
|---|---|
instances - [GCPInstance]
|
The list of GCP instances. |
nextCursor - String
|
The cursor for the next set of results. |
Example
{
"instances": [GCPInstance],
"nextCursor": "abc123"
}
GCPKeys
GCPSnapshot
Description
Represents a GCP snapshot.
Fields
| Field Name | Description |
|---|---|
id - String!
|
The unique ID of the snapshot. |
name - String!
|
The name of the snapshot. |
description - String!
|
The description of the snapshot. |
volumeName - String!
|
The source disk name of the snapshot. |
volumeId - String!
|
The source disk ID of the snapshot. |
volumeSize - Int!
|
The size of the snapshot in GB. |
status - String!
|
The status of the snapshot (e.g., READY, CREATING, DELETING). |
createdAt - String!
|
The timestamp when the snapshot was created. |
labels - [GcpLabels!]
|
Labels associated with the snapshot (key-value pairs). |
selfLink - String!
|
The self-link of the snapshot. |
storageLocations - [String!]!
|
The storage location of the snapshot. |
Example
{
"id": "abc123",
"name": "xyz789",
"description": "abc123",
"volumeName": "abc123",
"volumeId": "abc123",
"volumeSize": 123,
"status": "xyz789",
"createdAt": "abc123",
"labels": [GcpLabels],
"selfLink": "xyz789",
"storageLocations": ["xyz789"]
}
GCPSnapshotPaginatedResponse
Fields
| Field Name | Description |
|---|---|
snapshots - [GCPSnapshot!]
|
Array of GCP snapshot objects matching the query |
nextCursor - String
|
Cursor for next page of results (null if last page) |
Example
{
"snapshots": [GCPSnapshot],
"nextCursor": "abc123"
}
GCPSnapshotStatusUpdate
GCPVolumeAction
Description
Supported actions for managing GCP volumes.
- CREATE: Create a new GCP volume.
- DESCRIBE: Retrieve details of an existing GCP volume.
- ATTACH: Attach an existing GCP volume to an instance.
- DETACH: Detach a GCP volume from an instance.
- DELETE: Delete an existing GCP volume.
Values
| Enum Value | Description |
|---|---|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
Example
"CREATE"
GCPVolumePaginatedResponse
Description
Response type for the listGCPVolumes query.
Fields
| Field Name | Description |
|---|---|
volumes - [GCPDisk!]
|
The list of GCP volumes. |
nextCursor - String
|
The cursor for the next set of results. |
Example
{
"volumes": [GCPDisk],
"nextCursor": "abc123"
}
GcpAccessConfig
Description
Represents an access configuration for a GCP network interface.
Example
{
"name": "xyz789",
"natIP": "xyz789",
"type": "abc123"
}
GcpLabels
GcpNetworkInterface
Description
Represents a network interface for a GCP instance.
Fields
| Field Name | Description |
|---|---|
network - String
|
The network to which the interface is attached. |
subnetwork - String
|
The subnetwork of the interface. |
networkIP - String
|
The internal network IP. |
accessConfigs - [GcpAccessConfig]
|
The access configuration, including external IP. |
Example
{
"network": "abc123",
"subnetwork": "abc123",
"networkIP": "xyz789",
"accessConfigs": [GcpAccessConfig]
}
GcpScheduling
Description
Represents the scheduling information for a GCP instance.
Fields
| Field Name | Description |
|---|---|
preemptible - Boolean
|
Indicates if the instance is preemptible. |
Example
{"preemptible": true}
GcpSnapshotAction
Description
Enum for GCP snapshot actions.
Values
| Enum Value | Description |
|---|---|
|
|
Create a snapshot for a volume. |
|
|
Describe a snapshot by its ID. |
|
|
Restore a snapshot to its original volume. |
|
|
Delete a snapshot by its ID. |
Example
"CREATE"
Group
Fields
| Field Name | Description |
|---|---|
Keys - [String!]!
|
|
Metrics - Metrics!
|
|
Regions - [Region!]!
|
|
TimePeriod - TimePeriod
|
Example
{
"Keys": ["xyz789"],
"Metrics": Metrics,
"Regions": [Region],
"TimePeriod": TimePeriod
}
HasOwnCloud
Fields
| Field Name | Description |
|---|---|
provider - CloudProvider!
|
|
isOwnCloud - Boolean!
|
Example
{"provider": "GCP", "isOwnCloud": false}
IAMPermission
ID
Description
The ID scalar type represents a unique identifier, often used to refetch an object or as key for a cache. The ID type appears in a JSON response as a String; however, it is not intended to be human-readable. When expected as an input type, any string (such as "4") or integer (such as 4) input value will be accepted as an ID.
Example
"4"
IPType
Description
Represents the type of IP address.
Values
| Enum Value | Description |
|---|---|
|
|
Static IP address. |
|
|
Dynamic IP address. |
Example
"static"
InfraType
Description
Represents cloud infrastructure type.
Values
| Enum Value | Description |
|---|---|
|
|
|
|
|
Example
"PERSONAL"
InstanceStatusUpdate
Description
Represents an update to the status of an AWS instance.
Example
{
"id": "abc123",
"state": "abc123",
"publicIp": "xyz789",
"launchedAt": "xyz789"
}
InstanceUsageType
Values
| Enum Value | Description |
|---|---|
|
|
OnDemand Instance. |
|
|
Spot Instance. |
Example
"ON_DEMAND"
Int
Description
The Int scalar type represents non-fractional signed whole numeric values. Int can represent values between -(2^31) and 2^31 - 1.
Example
987
IpList
Description
Represents a list of AWS Elastic IPs.
Fields
| Field Name | Description |
|---|---|
AllocationId - String
|
The allocation ID of the Elastic IP. |
AssociationId - String
|
The association ID of the Elastic IP. |
InstanceId - String
|
The instance ID associated with the Elastic IP. |
PublicIp - String
|
The public IP address. |
NetworkBorderGroup - String
|
The network border group. |
Example
{
"AllocationId": "xyz789",
"AssociationId": "xyz789",
"InstanceId": "xyz789",
"PublicIp": "xyz789",
"NetworkBorderGroup": "xyz789"
}
JSON
Description
A custom scalar type for JSON data.
Example
{}
KeyPair
Description
Represents an AWS key pair.
Fields
| Field Name | Description |
|---|---|
name - String
|
The name of the key pair. |
Example
{"name": "xyz789"}
ManageGCPElasticIPResponse
Description
Union type for returning either minimal or full elasticIP details.
Types
| Union Types |
|---|
Example
ManageGCPElasticIPResponseMinimal
ManageGCPElasticIPResponseMinimal
Description
Represents the response for managing GCP Elastic IPs.
Fields
| Field Name | Description |
|---|---|
allocationId - String
|
The allocation ID of the Elastic IP. |
associationId - String
|
The association ID of the Elastic IP. |
publicIp - String
|
The public IP address. |
associatedTo - String
|
The instance associated with the Elastic IP. |
ipName - String
|
The name of the Elastic IP, known as address in GCP. |
Example
{
"allocationId": "abc123",
"associationId": "xyz789",
"publicIp": "xyz789",
"associatedTo": "xyz789",
"ipName": "abc123"
}
ManageGCPSnapshotResponse
Description
Union type for returning either minimal or full GCP snapshot details.
Types
| Union Types |
|---|
Example
ManageGCPSnapshotResponseMinimal
ManageGCPSnapshotResponseMinimal
Description
Response type for snapshot operations.
Fields
| Field Name | Description |
|---|---|
success - Boolean!
|
Indicates whether the operation was successful. |
message - String!
|
A message describing the result of the operation. |
snapshotId - String
|
The ID of the snapshot (if applicable). |
snapshot - GCPSnapshot
|
Details of the snapshot (if applicable). |
Example
{
"success": true,
"message": "xyz789",
"snapshotId": "xyz789",
"snapshot": GCPSnapshot
}
ManageGCPVolumeResponse
Description
Union type for returning either minimal or full volume details.
Types
| Union Types |
|---|
Example
ManageGCPVolumeResponseMinimal
ManageGCPVolumeResponseMinimal
Description
Minimal response type for the manageGCPVolume mutation. This type contains only the essential fields required for most operations.
Fields
| Field Name | Description |
|---|---|
volumeId - String
|
The unique identifier for the volume. |
volumeName - String
|
The name of the volume. |
zone - String
|
The GCP zone where the volume is located (e.g. asia-south1-a). |
attachedTo - String
|
The name of the instance attached to. |
deleteVolumeOnTermination - Boolean
|
Whether the disk will be automatically deleted when the instance is deleted |
isBootVolume - Boolean
|
Whether this disk is a boot disk |
Example
{
"volumeId": "xyz789",
"volumeName": "xyz789",
"zone": "xyz789",
"attachedTo": "xyz789",
"deleteVolumeOnTermination": true,
"isBootVolume": false
}
Metrics
Fields
| Field Name | Description |
|---|---|
UnblendedCost - UnblendedCost!
|
Example
{"UnblendedCost": UnblendedCost}
NewsEvent
PasswordDataResponse
Description
Represents the response for retrieving password data for an AWS instance.
Example
{
"success": false,
"password": "abc123",
"message": "abc123"
}
PaymentDetail
PaymentIntent
Region
Fields
| Field Name | Description |
|---|---|
RegionName - String!
|
|
UsageSubGroups - [UsageSubGroup!]!
|
Example
{
"RegionName": "abc123",
"UsageSubGroups": [UsageSubGroup]
}
Response
SSHKey
SizeInBytes
Description
Represents the size of a file system in bytes.
Example
{"Value": 987.65, "ValueInIA": 123.45, "ValueInStandard": 123.45}
Snapshot
Description
Represents an AWS snapshot.
Fields
| Field Name | Description |
|---|---|
snapshotId - String!
|
The ID of the snapshot. |
snapshotName - String!
|
The name of the snapshot. |
volumeId - String!
|
The ID of the volume from which the snapshot was created. |
region - String!
|
The region where the snapshot is located. |
progress - String!
|
The progress of the snapshot. |
state - String!
|
The state of the snapshot. |
volumeSize - Int!
|
The size of the volume from which the snapshot was created. |
volumeName - String!
|
The name of the volume from which the snapshot was created. |
startTime - String!
|
The start time of the snapshot. |
instanceId - String!
|
The ID of the instance from which the snapshot was created. |
instanceName - String!
|
The name of the instance from which the snapshot was created. |
snapshotStatus - String
|
The status of the snapshot. |
Example
{
"snapshotId": "xyz789",
"snapshotName": "xyz789",
"volumeId": "abc123",
"region": "abc123",
"progress": "abc123",
"state": "xyz789",
"volumeSize": 123,
"volumeName": "xyz789",
"startTime": "xyz789",
"instanceId": "xyz789",
"instanceName": "xyz789",
"snapshotStatus": "abc123"
}
String
Description
The String scalar type represents textual data, represented as UTF-8 character sequences. The String type is most often used by GraphQL to represent free-form human-readable text.
Example
"xyz789"
TimePeriod
TopupHistory
Fields
| Field Name | Description |
|---|---|
paymentDetails - [PaymentDetail!]!
|
|
receivedDate - String!
|
|
expDate - String!
|
|
credited - Float!
|
Example
{
"paymentDetails": [PaymentDetail],
"receivedDate": "xyz789",
"expDate": "xyz789",
"credited": 987.65
}
Total
Fields
| Field Name | Description |
|---|---|
UnblendedCost - UnblendedCost
|
|
Credits - UnblendedCost
|
|
Tax - UnblendedCost
|
Example
{
"UnblendedCost": UnblendedCost,
"Credits": UnblendedCost,
"Tax": UnblendedCost
}
UnblendedCost
UsageLink
Fields
| Field Name | Description |
|---|---|
costAndUsage - CloudUsage
|
|
estimatedCostUsage - Float!
|
|
platformFee - Float!
|
|
feePercentage - Float!
|
|
updatedAt - String!
|
Example
{
"costAndUsage": CloudUsage,
"estimatedCostUsage": 123.45,
"platformFee": 987.65,
"feePercentage": 987.65,
"updatedAt": "xyz789"
}
UsageSubGroup
Example
{
"ServiceName": "abc123",
"SKUName": "xyz789",
"UsageAmount": 123.45,
"UsageUnit": "xyz789",
"ResourceLabels": ["abc123"],
"TotalCost": 987.65,
"Credits": 987.65,
"Discounts": 987.65,
"TaxAmount": 987.65,
"TimePeriod": "abc123"
}
Volume
Description
Represents an AWS volume.
Fields
| Field Name | Description |
|---|---|
AvailabilityZone - String
|
The availability zone of the volume. |
CreateTime - String
|
The creation time of the volume. |
Size - Int
|
The size of the volume. |
SnapshotId - String
|
The snapshot ID from which the volume was created. |
State - String
|
The state of the volume. |
VolumeId - String
|
The ID of the volume. |
Name - String
|
The name of the volume. |
Iops - Int
|
The IOPS of the volume. |
VolumeType - String
|
The type of the volume. |
MultiAttachEnabled - Boolean
|
Whether the volume supports multiple attachments. |
Encrypted - Boolean
|
Whether the volume is encrypted. |
KmsKeyId - String
|
The KMS key ID used for encryption. |
OutpostArn - String
|
The ARN of the Outpost. |
Throughput - Int
|
The throughput of the volume. |
Attachments - [VolumeAttachment]
|
The attachments of the volume. |
volumeId - String
|
The ID of the volume. |
regionCode - String
|
The region code where the volume is located. |
state - String
|
The state of the volume. |
size - Int
|
The size of the volume. |
volumeType - String
|
The type of the volume. |
iops - Int
|
The IOPS of the volume. |
encrypted - Boolean
|
Whether the volume is encrypted. |
instanceId - String
|
The instance ID to which the volume is attached. |
device - String
|
The device name of the volume. |
Example
{
"AvailabilityZone": "xyz789",
"CreateTime": "xyz789",
"Size": 123,
"SnapshotId": "abc123",
"State": "xyz789",
"VolumeId": "xyz789",
"Name": "xyz789",
"Iops": 123,
"VolumeType": "xyz789",
"MultiAttachEnabled": false,
"Encrypted": false,
"KmsKeyId": "xyz789",
"OutpostArn": "xyz789",
"Throughput": 987,
"Attachments": [VolumeAttachment],
"volumeId": "abc123",
"regionCode": "xyz789",
"state": "xyz789",
"size": 987,
"volumeType": "xyz789",
"iops": 123,
"encrypted": false,
"instanceId": "abc123",
"device": "abc123"
}
VolumeAction
Description
Represents an action that can be performed on an AWS volume.
Values
| Enum Value | Description |
|---|---|
|
|
Create the volume. |
|
|
Describe the volume. |
|
|
Attach the volume. |
|
|
Detach the volume. |
|
|
Delete the volume. |
Example
"create"
VolumeAttachment
Description
Represents an AWS volume attachment..
Fields
| Field Name | Description |
|---|---|
AttachTime - String
|
The time the attachment occurred. |
Device - String
|
The device name of the volume. |
InstanceId - String
|
The instance ID to which the volume is attached. |
State - String
|
The state of the attachment. |
DeleteOnTermination - Boolean
|
Whether the volume should be deleted when the instance is terminated. |
Example
{
"AttachTime": "abc123",
"Device": "abc123",
"InstanceId": "xyz789",
"State": "abc123",
"DeleteOnTermination": false
}